package com.tptj.demo.hg.lifecycle.monitor;

import com.fr.decision.webservice.v10.login.LoginService;
import com.fr.invoke.Reflect;
import com.fr.plugin.context.PluginContext;
import com.fr.plugin.observer.inner.AbstractPluginLifecycleMonitor;
import com.fr.record.analyzer.EnableMetrics;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-05-21
 * 这个接口本身功能定义边界比较大，用于插件自身声明周期内对环境做一些预处理（启动后）和卸载（插件停止前）动作
 * 但是没有界定边界，也就是只要技术手段可行，似乎我们都可以利用这个接口去干预整个产品主体的运行
 * 特别对于各种service controller manager config 之类的单例非静态的方法逻辑
 * 这样在方便至于也带来了非常大的风险，因为这些方法逻辑被插件干预后，产品是收集不到这些信息的，
 * 在产品迭代更新过程中就非常容易出现不兼容的情况！
 * 所以我们使用时需要特别谨慎！
 **/

public class Demo extends AbstractPluginLifecycleMonitor {
    @Override
    public void afterRun(PluginContext pluginContext) {
        //再次强调，这个例子仅仅是为了说明功能，切勿在实际项目中使用这种方式
        Reflect.on(LoginService.getInstance()).set( "instance", new DemoLoginService() );
    }

    @Override
    public void beforeStop(PluginContext pluginContext) {
        Reflect.on(LoginService.getInstance()).set( "instance", new LoginService() );
    }
}
